<?php
/*
Plugin Name: Digg This Button
Plugin URI: http://netweblogic.com/wordpress/digg-this-button/
Description: Adds the smarter digg button. Extended options like topics, prefilled descriptions, shortcodes etc. allow full control of your digg icons.
Author: NetWebLogic LLC
Version: 1.0
Author URI: http://netweblogic.com
*/
/*
Copyright (C) 2008 NetWebLogic LLC

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

class DiggThisButton {

	var $topicArray = array('arts_culture' => 'arts_culture', 'autos' => 'autos', 'baseball' => 'baseball', 'basketball' => 'basketball', 'business_finance' => 'business_finance', 'celebrity' => 'celebrity', 'comedy' => 'comedy', 'comics_animation' => 'comics_animation', 'design' => 'design', 'educational' => 'educational', 'environment' => 'environment', 'extreme_sports' => 'extreme_sports', 'food_drink' => 'food_drink', 'football' => 'football', 'gadgets' => 'gadgets', 'gaming_news' => 'gaming_news', 'general_sciences' => 'general_sciences', 'golf' => 'golf', 'hardware' => 'hardware', 'health' => 'health', 'hockey' => 'hockey', 'linux_unix' => 'linux_unix', 'microsoft' => 'microsoft', 'mods' => 'mods', 'motorsport' => 'motorsport', 'movies' => 'movies', 'music' => 'music', 'nintendo' => 'nintendo', 'odd_stuff' => 'odd_stuff', 'olympics' => 'olympics', 'other_sports' => 'other_sports', 'pc_games' => 'pc_games', 'people' => 'people', 'pets_animals' => 'pets_animals', 'playable_web_games' => 'playable_web_games', 'playstation' => 'playstation', 'political_opinion' => 'political_opinion', 'politics' => 'politics', 'programming' => 'programming', 'security' => 'security', 'soccer' => 'soccer', 'software' => 'software', 'space' => 'space', 'tech_news' => 'tech_news', 'television' => 'television', 'tennis' => 'tennis', 'travel_places' => 'travel_places', 'world_news' => 'world_news', 'xbox' => 'xbox');
	var $skinArray = array('default' => '', 'compact' => 'compact', 'icon'=>'icon');
	var $mediaArray = array('video', 'image', 'news');
	var $posH = array('right', 'left', 'none');
	var $posV = array('top', 'bottom');
	var $shortcode = false;
	var $diggthis_data;
	
	// Class initialization
	function DiggThisButton() {
		//Make decision on what to display
		/*if ( function_exists('register_sidebar_widget') ){
			//Coming Soon
			//register_sidebar_widget('Digg This', array(&$this, 'widget'));
		}*/
		$this->diggthis_data = get_option('diggthis_data');
		add_filter('the_content', array(&$this, 'content'));
		add_filter('the_excerpt', array(&$this, 'content'));
		add_action('admin_menu', array(&$this, 'admin_pages'));
		add_action('admin_init', array(&$this, 'admin_scripts'));
		add_action('admin_head', array(&$this, 'admin_head'));
		add_shortcode('diggthis', array(&$this, 'shortcode'));	
	}
	
	function content($content){
		if($this->inProgress != true){
			$this->inProgress = true; //to stop from adding it to the excerpt if doing this here.
			//Check whether we are to show this
			$display = false;
			$display = ($this->diggthis_data['display_pages']=='1' && is_page()) ? true:$display;
			$display = ($this->diggthis_data['display_posts']=='1' && is_single()) ? true:$display;
			$display = ($this->diggthis_data['display_lists']=='1' && !is_singular()) ? true:$display;
			if($display){
				ob_start();
				$this->display();
			}
			$button = ob_get_clean();
			if($this->diggthis_data['pos_v'] == 'bottom'){
				$content = $content . $button;
			}else{
				$content = $button . $content;
			}
			$this->inProgress = false;
			return $content;
		}
	}
	
	function shortcode( $atts = array() ){
		ob_start();
		$this->shortcode = true;
		$atts = (is_array($atts)) ? $atts : array();
		unset($this->diggthis_data['pos_h']);
		unset($this->diggthis_data['pos_v']);
		$this->display( $atts );
		$this->diggthis_data = get_option('diggthis_data');
		$this->shortcode = false;
		return ob_get_clean();
	}
	
	function display( $atts = array() ){
		$diggthis_data = array_merge( $this->diggthis_data, $atts);
		$style = '';
		if( $diggthis_data['style'] == '' && $this->shortcode != true ){
			switch ( $diggthis_data['pos_h']) {
				case 'left' :
					$style .= 'float:left;';
					if($diggthis_data['pos_v'] == 'bottom'){
						$style .= 'margin:0px 10px 10px 0px;';
					}elseif ($diggthis_data['pos_v'] == 'top'){
						$style .= 'margin:10px 10px 0px 0px;';
					}
					break;
				default :
					$style .= 'float:right;';
					if($diggthis_data['pos_v'] == 'bottom'){
						$style .= 'margin:10px 10px 0px 0px;';
					}elseif ($diggthis_data['pos_v'] == 'top'){
						$style .= 'margin:0px 0px 10px 10px;';
					}
					break;
			}
		}else{
			$style = $diggthis_data['style']; 
		}
		?>
		<div style="<?= $style ?>">
			<script type="text/javascript">
				digg_url = '<?= the_permalink(); ?>';
				digg_title = '<?= the_title(); ?>';
				digg_bodytext = "<?= the_excerpt_rss(); ?>";
				<?php if( in_array($diggthis_data['skin'], $this->skinArray) ): ?>
					digg_skin = '<?= $diggthis_data['skin'] ?>';
				<?php endif; ?>
				<?php if( in_array($diggthis_data['topic'], $this->topicArray) ): ?>
					digg_topic = '<?= $diggthis_data['topic'] ?>';
				<?php endif; ?>
				<?php if( isset($diggthis_data['bgcolor']) ): ?>
					digg_bgcolor = '<?= $diggthis_data['bgcolor'] ?>';
				<?php endif; ?>
				<?php if( $diggthis_data['window'] == '1' or $diggthis_data['window'] == 'new'): ?>
					digg_window = 'new';
				<?php endif; ?>
				<?php if( in_array($diggthis_data['media'], $this->mediaArray ) ): ?>
					digg_media = '<?= $diggthis_data['skin'] ?>';
				<?php endif; ?>
			</script>
			<script src="http://digg.com/tools/diggthis.js" type="text/javascript"></script> 		
		</div>
		<?php
	}
		
	function admin_pages(){
		$page = add_options_page('Digg This Button', 'Digg This Button', 8, 'diggthisbutton', array(&$this, 'admin_settings'));
	}

	function admin_scripts() {
		if( $_GET['page'] == 'diggthisbutton' ){
			wp_enqueue_script( "dtb-color", "/".PLUGINDIR."/digg-this-button/colorpicker/farbtastic.js", array( 'jquery' ) );
			wp_enqueue_style( "dtb-color", "/".PLUGINDIR."/digg-this-button/colorpicker/farbtastic.css" );
		}
	}
	
	function admin_head() {
		if( $_GET['page'] == 'diggthisbutton' ){
		?>
		<script type="text/javascript">
			jQuery(document).ready(function($) {
				//$('#colorpicker').farbtastic('#diggthis_bgcolor');
			});
			jQuery(document).ready(function($){
				$("#diggthis_bgcolor").focus(function(e){
					$("#colorpicker").fadeIn('slow', (function(){ $("#colorpicker").css('display', 'inline'); }));
				});
				$("#diggthis_bgcolor").blur(function(e){
					$("#colorpicker").fadeOut('slow', (function(){ $("#colorpicker").css('display', 'none'); }) );
				});
				var diggthis_bgcolor = function(color){
					$("#diggthis_bgcolor").val(color);
					$("#diggthis_bgcolor").css('background-color', color);
				}
				$.farbtastic("#colorpicker", diggthis_bgcolor).setColor($("#diggthis_bgcolor").val());
			});
		</script>
		<?php
		}
	}
	
	function admin_settings() {
		
		if( is_admin() and $_POST['diggthisbutton_submitted']==1 ){
		
			add_option('diggthis_data');
			$diggthis_data = array();
			
			//Build the array of options here
			if(!$errors){
				foreach ($_POST as $postKey => $postValue){
					if( substr($postKey, 0, 8) == 'diggthis' ){
						//For now, no validation, since this is in admin area.
						if($postValue != ''){
							$diggthis_data[substr($postKey, 9)] = $postValue;
						}
					}
				}
				update_option('diggthis_data', $diggthis_data);
				$this->diggthis_data = $diggthis_data;
				?>
				<div class="updated"><p><strong><?php _e('Options saved.'); ?></strong></p></div>
				<?php
			}else{
				?>
				<div class="error"><p><strong><?php _e('There were issues when saving your settings. Please try again.'); ?></strong></p></div>
				<?php				
			}
		}
		?>
		<div class="wrap">
			<h2>Digg This Settings</h2>
			<p>If you have any suggestions, come over to our plugin page and leave a comment. It may just happen!</p>
			<form method="post" action="<?php echo str_replace( '%7E', '~', $_SERVER['REQUEST_URI']); ?>">
				<table class="form-table">
					<tbody id="diggthis-body">
						<tr valign="top" id="diggthis-display-posts">
							<td scope="row">
								<label>Display on Posts?</label>
							</td>
							<td>
								<input type="checkbox" name="diggthis_display_posts" value="1" <?= ($this->diggthis_data['display_posts'] == 1) ? 'checked="checked"':'' ?> /> 
							</td>
						</tr>
						<tr valign="top" id="diggthis-display-pages">
							<td scope="row">
								<label>Display on Pages?</label>
							</td>
							<td>
								<input type="checkbox" name="diggthis_display_pages" value="1" <?= ($this->diggthis_data['display_pages'] == 1) ? 'checked="checked"':'' ?> /> 
							</td>
						</tr>
						<tr valign="top" id="diggthis-display-lists">
							<td scope="row">
								<label>Display on Post Lists?</label>
							</td>
							<td>
								<input type="checkbox" name="diggthis_display_lists" value="1" <?= ($this->diggthis_data['display_lists'] == 1) ? 'checked="checked"':'' ?> /><br/>
								<i>e.g. Archives, Front Page, Tag Pages, Searches, etc.</i> 
							</td>
						</tr>
						<tr valign="top">
							<td scope="row">
								<label>Digg Skin</label>
							</td>
							<td>
								<select name="diggthis_skin" id="diggthis_skin">
									<?php
									foreach( $this->skinArray as $title => $value ){
										?>
											<option value="<?= $value ?>" <?= ($this->diggthis_data['skin'] == $value) ? 'selected="selected"':'' ?>><?= $title ?></option>
										<?php
									}
									?>
								</select>
							</td>
						</tr>
						<tr valign="top">
							<td scope="row">
								<label>Digg Topic</label>
							</td>
							<td>
								<select name="diggthis_topic" id="diggthis_topic">
									<option value="">Select...</option>
									<?php
									foreach( $this->topicArray as $title => $value ){
										?>
											<option value="<?= $value ?>" <?= ($this->diggthis_data['topic'] == $value) ? 'selected="selected"':'' ?>><?= $title ?></option>
										<?php
									}
									?>
								</select>
								<br/>
								<i>This setting currently applies across all posts and pages. Specific categorizing coming soon!</i> 
							</td>
						</tr>
						<tr valign="top">
							<td scope="row">
								<label>Digg Icon Background Color</label>
							</td>
							<td>
								<input type="text" name="diggthis_bgcolor" id="diggthis_bgcolor" value='<?= $this->diggthis_data['bgcolor'] ?>' style="float:left;" />
								<span style="position:absolute; background:#DEDEDE; border:1px solid #CDCDCD; display:none;" id="colorpicker"></span>
								<br style="clear:both;"/>
								<i>Use any valid CSS colour, e.g. #ff9900</i> 
							</td>
						</tr>
						<tr valign="top">
							<td scope="row">
								<label>Where should the icon go in your post/page?</label>
							</td>
							<td>
								Top/Bottom : <select name="diggthis_pos_v" id="diggthis_pos_v">
									<?php
									foreach( $this->posV as $value ){
										?>
											<option value="<?= $value ?>" <?= ($this->diggthis_data['pos_v'] == $value) ? 'selected="selected"':'' ?>><?= $value ?></option>
										<?php
									}
									?>
								</select>
								Float : <select name="diggthis_pos_h" id="diggthis_pos_h">
									<?php
									foreach( $this->posH as $value ){
										?>
											<option value="<?= $value ?>" <?= ($this->diggthis_data['pos_h'] == $value) ? 'selected="selected"':'' ?>><?= $value ?></option>
										<?php
									}
									?>
								</select>
							</td>
						</tr>
						<tr valign="top">
							<td scope="row">
								<label>Inline Style</label>
							</td>
							<td>
								<input type="text" name="diggthis_style" value="<?= $this->diggthis_data['style'] ?>" style="width:100%;" />
								<br/>
								<i>Enter your CSS here, which goes in the containing div. Example : <code>margin:5px; padding:5px;</code></i> <br />
								<i><strong>Important : </strong>If you place a value here, the display options above this (float and top/bottom) will not apply. Leave blank to reset.</i> 
							</td>
						</tr>
						<tr valign="top">
							<td scope="row">
								<label>Open Digg in New Window?</label>
							</td>
							<td>
								<input type="checkbox" name="diggthis_window" value="1" <?= ($this->diggthis_data['window'] == 1) ? 'checked="checked"':'' ?> />
								<br/>
								<i>When checked, any clicks open in a new window, as opposed to the default which is to open links in the same browser window.</i> 
							</td>
						</tr>

					</tbody>
					<tfoot>
						<tr valign="top">
							<td colspan="2">	
								<input type="hidden" name="diggthisbutton_submitted" value="1" />
								<p class="submit">
									<input type="submit" class="button-primary" value="<?php _e('Save Changes') ?>" />
								</p>							
							</td>
						</tr>
					</tfoot>
				</table>
			</form>
		</div>
		<?php
	}
}

// Start this plugin once all other plugins are fully loaded
add_action( 'init', create_function( '', 'global $DiggThisButton; $DiggThisButton = new DiggThisButton();' ) );

//Shortcut
function diggthisbutton( $atts=array() ){
	global $DiggThisButton;
	echo $DiggThisButton->shortcode($atts);	
}

?>